; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib

    include \masm32\macros\macros.asm

    include timers.asm

    atodw_no_xor_eaxeax   PROTO :DWORD
    atodw_no_pushpop_edi  PROTO :DWORD

; 
    .data
      teststr db "123456789",0
    .code
; 
start: 
; 
    LOOP_COUNT EQU 10000000

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke atodw, ADDR teststr
    counter_end
    mov   ebx,eax
    print chr$("atodw                : ")
    print ustr$(ebx)
    print chr$(" cycles", 13, 10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke atodw_no_pushpop_edi, ADDR teststr
    counter_end
    mov   ebx,eax
    print chr$("atodw_no_pushpop_edi : ")
    print ustr$(ebx)
    print chr$(" cycles", 13, 10)    

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke atodw_no_xor_eaxeax, ADDR teststr
    counter_end
    mov   ebx,eax
    print chr$("atodw_no_xor_eaxeax  : ")
    print ustr$(ebx)
    print chr$(" cycles", 13, 10)
    
    mov   eax, input(13, 10, "Press enter to exit...")
    exit   

; 
; Copies to play with.    
; 
atodw_no_pushpop_edi proc String:DWORD

  ; ----------------------------------------
  ; Convert decimal string into dword value
  ; return value in eax
  ; ----------------------------------------

    push esi
    ;push edi

    xor eax, eax
    mov esi, [String]
    xor ecx, ecx
    xor edx, edx
    mov al, [esi]
    inc esi
    cmp al, 2D
    jne proceed
    mov al, byte ptr [esi]
    not edx
    inc esi
    jmp proceed

  @@: 
    sub al, 30h
    lea ecx, dword ptr [ecx+4*ecx]
    lea ecx, dword ptr [eax+2*ecx]
    mov al, byte ptr [esi]
    inc esi

  proceed:
    or al, al
    jne @B
    lea eax, dword ptr [edx+ecx]
    xor eax, edx

    ;pop edi
    pop esi

    ret

atodw_no_pushpop_edi endp

atodw_no_xor_eaxeax proc String:DWORD

  ; ----------------------------------------
  ; Convert decimal string into dword value
  ; return value in eax
  ; ----------------------------------------

    push esi
    push edi

    ;xor eax, eax
    mov esi, [String]
    xor ecx, ecx
    xor edx, edx
    mov al, [esi]
    inc esi
    cmp al, 2D
    jne proceed
    mov al, byte ptr [esi]
    not edx
    inc esi
    jmp proceed

  @@: 
    sub al, 30h
    lea ecx, dword ptr [ecx+4*ecx]
    lea ecx, dword ptr [eax+2*ecx]
    mov al, byte ptr [esi]
    inc esi

  proceed:
    or al, al
    jne @B
    lea eax, dword ptr [edx+ecx]
    xor eax, edx

    pop edi
    pop esi

    ret

atodw_no_xor_eaxeax endp

; 
end start
